﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Forms
{
    public partial class MainPage : ContentPage
    {
        StaffViewModel viewModel;
        public MainPage()
        {
               InitializeComponent();
                BindingContext = viewModel = new StaffViewModel();
            }

        protected override void OnAppearing()
        {
            base.OnAppearing();
            if (viewModel.StaffMembers.Count == 0)
            {
                viewModel.LoadStaffCommand.Execute(null);
            }
        }
    }
    #region View Models

    public class StaffViewModel : BaseViewModel
    {
        public ObservableCollection<Staff> StaffMembers { get; set; }
        public Command LoadStaffCommand { get; set; }

        public StaffViewModel()
        {
           // Title = "Staff";
            StaffMembers = new ObservableCollection<Staff>();
            GenerateCollection(StaffMembers);
            //LoadStaffCommand = new Command(async () => await ExecuteLoadStaffCommand());
        }

        private void GenerateCollection(ObservableCollection<Staff> staffMembers)
        {
            var phone1 = new Phone() { Id = 1, StaffId = 101, PhoneNumber = "123-456", PhoneType = "IP1" };
            var phone2 = new Phone() { Id = 2, StaffId = 101, PhoneNumber = "456-123", PhoneType = "IP2" };
            var phone3 = new Phone() { Id = 3, StaffId = 101, PhoneNumber = "789-123", PhoneType = "IP3" };
            var phone4 = new Phone() { Id = 4, StaffId = 101, PhoneNumber = "897-234", PhoneType = "IP4" };
            var phone5 = new Phone() { Id = 5, StaffId = 102, PhoneNumber = "978-543", PhoneType = "IP5" };
            var phone6 = new Phone() { Id = 5, StaffId = 102, PhoneNumber = "978-543", PhoneType = "IP6" };
            var phone7 = new Phone() { Id = 5, StaffId = 102, PhoneNumber = "978-543", PhoneType = "IP7" };
            var phone8 = new Phone() { Id = 5, StaffId = 103, PhoneNumber = "978-543", PhoneType = "IP8" };
            var phone9 = new Phone() { Id = 5, StaffId = 103, PhoneNumber = "978-543", PhoneType = "IP9" };

            var staff1 = new Staff() { Id = 101, StaffName = "Kyle", StaffPhones = new List<Phone>() { phone1, phone2, phone3, phone4 } };
            var staff2 = new Staff() { Id = 102, StaffName = "Gina", StaffPhones = new List<Phone>() { phone5, phone6, phone7 } };
            var staff3 = new Staff() { Id = 103, StaffName = "Adam", StaffPhones = new List<Phone>() { phone8, phone9 } };
            staffMembers.Add(staff1);
            staffMembers.Add(staff2);
            staffMembers.Add(staff3);
        }

        //async Task ExecuteLoadStaffCommand()
        //{
        //    if (IsBusy)
        //        return;
        //    IsBusy = true;

        //    var staff = await DataStore.GetStaffAsync();

        //    foreach (var person in staff)
        //    {
        //        StaffMembers.Add(person);
        //    }
        //    IsBusy = false;
        //}
    }

    #endregion
    #region Models
    public class Staff : INotifyPropertyChanged
    {
        int id;
        string staffName;
        List<Phone> staffPhones;

        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                RaisedOnPropertyChanged("Id");
            }
        }
        public string StaffName
        {
            get { return staffName; }
            set
            {
                staffName = value;
                RaisedOnPropertyChanged("StaffName");
            }
        }
        public List<Phone> StaffPhones
        {
            get { return staffPhones; }
            set
            {
                staffPhones = value;
                RaisedOnPropertyChanged("StaffPhones");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }
    } 

    public class Phone
    {

        int id;
        private int staffId;
        private string phoneType;
        private string phoneNumber;

        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                RaisedOnPropertyChanged("Id");
            }
        }
        public int StaffId
        {
            get { return staffId; }
            set
            {
                staffId = value;
                RaisedOnPropertyChanged("StaffId");
            }
        }
        public string PhoneType
        {
            get { return phoneType; }
            set
            {
                phoneType = value;
                RaisedOnPropertyChanged("PhoneType");
            }
        }
        public string PhoneNumber
        {
            get { return phoneNumber; }
            set
            {
                phoneNumber = value;
                RaisedOnPropertyChanged("PhoneNumber");
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }
    }
    #endregion
}
